
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import java.io
import jpype
import org.hipparchus.linear
import org.hipparchus.stat.descriptive
import typing



class VectorialCovariance(java.io.Serializable):
    def __init__(self, int: int, boolean: bool): ...
    def clear(self) -> None: ...
    def equals(self, object: typing.Any) -> bool: ...
    def getN(self) -> int: ...
    def getResult(self) -> org.hipparchus.linear.RealMatrix: ...
    def hashCode(self) -> int: ...
    def increment(self, doubleArray: typing.Union[typing.List[float], jpype.JArray]) -> None: ...

class VectorialStorelessStatistic(org.hipparchus.stat.descriptive.StorelessMultivariateStatistic, java.io.Serializable):
    def __init__(self, int: int, storelessUnivariateStatistic: org.hipparchus.stat.descriptive.StorelessUnivariateStatistic): ...
    def clear(self) -> None: ...
    def equals(self, object: typing.Any) -> bool: ...
    def getDimension(self) -> int: ...
    def getN(self) -> int: ...
    def getResult(self) -> typing.MutableSequence[float]: ...
    def hashCode(self) -> int: ...
    def increment(self, doubleArray: typing.Union[typing.List[float], jpype.JArray]) -> None: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.hipparchus.stat.descriptive.vector")``.

    VectorialCovariance: typing.Type[VectorialCovariance]
    VectorialStorelessStatistic: typing.Type[VectorialStorelessStatistic]
