
import sys
if sys.version_info >= (3, 8):
    from typing import Protocol
else:
    from typing_extensions import Protocol

import jpype
import typing



class PCA:
    @typing.overload
    def __init__(self, int: int): ...
    @typing.overload
    def __init__(self, int: int, boolean: bool, boolean2: bool): ...
    def fit(self, doubleArray: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray]) -> 'PCA': ...
    def fitAndTransform(self, doubleArray: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray]) -> typing.MutableSequence[typing.MutableSequence[float]]: ...
    def getCenter(self) -> typing.MutableSequence[float]: ...
    def getComponents(self) -> typing.MutableSequence[typing.MutableSequence[float]]: ...
    def getNumComponents(self) -> int: ...
    def getVariance(self) -> typing.MutableSequence[float]: ...
    def isBiasCorrection(self) -> bool: ...
    def isScale(self) -> bool: ...
    def transform(self, doubleArray: typing.Union[typing.List[typing.MutableSequence[float]], jpype.JArray]) -> typing.MutableSequence[typing.MutableSequence[float]]: ...


class __module_protocol__(Protocol):
    # A module protocol which reflects the result of ``jp.JPackage("org.hipparchus.stat.projection")``.

    PCA: typing.Type[PCA]
